//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997 - 2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	SimpleScanner.h	--- defines the SimpleScanner class which represents
//                          a simple scanner.
//
//	DESCRIPTION:
//
//	USAGE EXAMPLES:
//
//	CHANGE HISTORY:
//
//	AUTHOR:
//		M.Thomas
//
//	REFERENCES:
//
//	$Header: /data/xmm12/cvsadmin/soc_repos/sas/packages/utils/src/SimpleScanner.h,v 1.2 2000/02/22 14:35:37 mthomas Exp $
///

#ifndef SIMPLE_SCANNER_H
#define SIMPLE_SCANNER_H


#include "SimpleToken.h"


class SimpleScanner
{
	public :

		SimpleScanner( const string& s, const string& separators );
		~SimpleScanner();

		class Expected {
		public :
			Expected( const string& message );
			string message() const;
		private :
			string	_message;
		};

		bool 		eof() const;
		const 		SimpleToken& next() const;
		bool	 	nextIsCharacter( char thisCharacter ) const;
		bool 		nextIsString() const;
		SimpleToken 	accept();
		void 		skip();
		SimpleToken 	match( SimpleToken::Id id ) throw( Expected );
		SimpleToken 	match( char c ) throw( Expected );
		string		remainder() const;

	private :

		SimpleToken	_lookahead;
		void		fetchNextToken();
		string		_source;
		istream&	_ifs;
		string		_separators;
};

#endif

