//
//	rantest: test the random number generator (simple)
//
//	UL, Fri May 28 17:56:18 MET DST 1999
//
//	$Header: /data/xmm12/cvsadmin/soc_repos/sas/packages/utils/test/rantest.cc,v 1.2 1999/06/08 16:08:42 ulammers Exp $
//
#include <iostream>
#include <cassert>

#include "Random.h"

void fillbuf(double *buff, unsigned N)
{
	for (unsigned n=0; n<N; buff[n++] = randGen.rand());
}

int main()
{
	const unsigned N = 200;

	double rns1[N], rns2[N];

	fillbuf(rns1, N);
	randGen.reset();
	fillbuf(rns2, N);

	for (unsigned n=0; n<N; ++n) {
		assert(rns1[n] >= 0. && rns1[n] <= 1.);
		assert(rns1[n] == rns2[n]);
	}

	randGen.seed(12345);
	fillbuf(rns1, N);
	for (unsigned n=0; n<N; ++n)
		assert(rns1[n] != rns2[n]);


	const double min = -123;
	const double max = 999;
	randGen.min(min);
	randGen.max(max);
	fillbuf(rns1, N);

	for (unsigned n=0; n<N; ++n) {
		cout<<rns1[n]<<endl;
		assert(min <= rns1[n]  && max >= rns1[n]);
	}

	return 0;
}
