#include "QuotedString.h"
#include <strstream>
#include <cassert>

int main()
{
  string a,b;
  assert( a == b );

 {
  strstream s;
  QuotedString qs;
  s << "foo bar" << ends;
  s >> qs;
  assert(qs == string("foo"));
  s >> qs; 
  assert(qs == string("bar"));
  s >> qs;
  assert(!s);
 }
 
 {
  strstream s;
  QuotedString qs;
  s << "\"foo bar\" foo1" << ends;
  s >> qs;
  assert(qs == string("foo bar"));
  s >> qs;
  assert(qs == string("foo1"));
  s >> qs;
  assert(!s);
 }

 {
  QuotedString qs("foo bar");
  qs.quotes('(',')');
  strstream s;
  s << qs << ends;
  string ss;
  s >> ss;
  assert(ss == string("(foo"));
  s >> ss;
  assert(ss == string("bar)")+'\0'); // workaround for string bug: appends 0
 }

 {
  QuotedString qs;
  strstream s;
  s << qs << ends;
  string ss("foo");
  s >> ss;
  assert(ss == string("\"\"")+'\0'); // workaround for string bug: appends 0
  s >> ss;
  assert(!s);
 }

 {
  QuotedString qs;
  strstream s;
  s << qs << ends;
  QuotedString ss("foo");
  s >> ss;
  assert(ss.length() == 0);
 }
 return 0;
}



